Works with Java 1.6 as well.